import { Connection } from "rabbitmq-client";

const rabbit = new Connection("amqp://guest:guest@localhost:5672");
rabbit.on("error", (err) => console.log("RabbitMQ connection error", err));
rabbit.on("connection", () =>
  console.log("Connection successfully (re)established")
);

const topics = new Array(200).fill(0).map((_, i) => i.toString());

const sampleClient = rabbit.createConsumer(
  {
    queue: "events",
    queueOptions: {
      durable: false,
    },
    qos: {
      prefetchCount: 2,
    },
    exchanges: [
      {
        exchange: "events",
        type: "topic",
      },
    ],
    queueBindings: topics.map((routingKey) => ({
      exchange: "events",
      routingKey,
    })),
  },
  async (msg) => {
    console.info(msg);
  }
);

sampleClient.on("error", (err) => {
  // Maybe the consumer was cancelled, or the connection was reset before a
  // message could be acknowledged.
  console.log("consumer error (user-events)", err);
});
