import rabbit from "rabbitmq-stream-js-client";

// const streamName = "hello-nodejs-stream";
const streamName = "dynamic-test";

const client = await rabbit.connect({
  hostname: "localhost",
  port: 5552,
  username: "guest",
  password: "guest",
  vhost: "/",
});

const streamSizeRetention = 5 * 1e9;
await client.createStream({
  stream: streamName,
  arguments: { "max-length-bytes": streamSizeRetention },
});

const sub = await client.declareConsumer(
  {
    stream: streamName,
    // offset: rabbit.Offset.timestamp(new Date(1718554112024)),
    offset: rabbit.Offset.next(),
    filter: {
      values: ["my-topic", "b"],
      postFilterFunc() {
        // (msg) {
        // console.info("try filter", msg);
        return true;
      },
      matchUnfiltered: false,
    },
  },
  async (message) => {
    console.log(message);
    console.log(`Received message ${message.content.toString()}`);
    // console.log("Current offset:", await sub.queryOffset());
  }
);
