import rabbit from "rabbitmq-stream-js-client";

// const streamName = "hello-nodejs-stream";
const streamName = "dynamic-test";

console.log("Connecting...");
const client = await rabbit.connect({
  vhost: "/",
  port: 5552,
  hostname: "localhost",
  username: "guest",
  password: "guest",
});

console.log("Making sure the stream exists...");
const streamSizeRetention = 5 * 1e9;
await client.createStream({
  stream: streamName,
  arguments: { "max-length-bytes": streamSizeRetention },
});

const publisher = await client.declarePublisher(
  { stream: streamName },
  (msg) => {
    console.info(msg);
    return "my-topic";
  }
);

console.log("Sending a message...");
// console.info(+new Date());
await publisher.send(Buffer.from("Test message 3nd"));

await client.close();
