let
  # Pinned nixpkgs, deterministic. Last updated: 17-06-2024.
  pkgs = import (fetchTarball("https://github.com/NixOS/nixpkgs/archive/219bc27bcfeaa0c0cc9627a8fe651d33d8da9c9a.tar.gz")) {};

  # Rolling updates, not deterministic.
  # pkgs = import (fetchTarball("channel:nixpkgs-unstable")) {};
in pkgs.mkShell {
  buildInputs = [
    # Tools
    pkgs.git

    # Bun
    pkgs.bun

    # Cargo
    pkgs.cargo
    pkgs.rustc
    pkgs.clippy
    pkgs.rustfmt
    pkgs.pkg-config
    pkgs.openssl.dev
  ];

  RUST_SRC_PATH = "${pkgs.rust.packages.stable.rustPlatform.rustLibSrc}";
}
