# RabbitMQ Test Project

Playground for experimenting with RabbitMQ.

Use the Nix shell! `nix-shell`

Start RabbitMQ using Docker: `docker compose up -d`

## Multiple publishers, multiple consumers

Start one or more consumers for `my-topic`:

```bash
# using Node.js RabbitMQ stream client
bun run ./1-nodejs-rabbitmq-stream-client/recv.ts

# using Rust Lapin library
cd ./2-lapin-rust && cargo run --example recv
```

Now start publishing stuff:

```bash
# using Node.js RabbitMQ stream client
bun run ./1-nodejs-rabbitmq-stream-client/send.ts

# using Rust Lapin library
cd ./2-lapin-rust && cargo run --example send
```

## Dynamic subscription tests

The initial proof of concept written in Javascript:

```bash
bun run ./1-nodejs-rabbitmq-stream-client/dynamicSubscriptionTest.ts
```

And re-written in Rust:

```bash
cd ./2-lapin-rust && cargo run --example dynamic
```
